#!/bin/sh
echo "Don't forget to update this script with the change-log!
Press ENTER to start..."
read

NAME="libxmlrpc"
SOURCE="http://xmlrpc-c.svn.sourceforge.net/svnroot/xmlrpc-c/advanced"
CONFIGURE="--prefix=/usr/local --disable-wininet-client --disable-curl-client --disable-libwww-client"
DATE=`date '+%Y/%m/%d'`
SCRIPT_NAME=$(basename $0)
cp $0 /tmp/
export CFLAGS="-march=i486 -mtune=i686 -Os -pipe"
export CXXFLAGS="-march=i486 -mtune=i686 -Os -pipe"
export LDFLAGS="-Wl,-O1"

echo "Downloading essential packages..."
tce-load -wi compiletc squashfs-tools-4.x autoconf automake svn

cd /tmp/
svn co $SOURCE
cd advanced

VERSION1=`grep 'XMLRPC_MAJOR_RELEASE' version.mk|cut -d'=' -f2|tr -d ' '`
VERSION2=`grep 'XMLRPC_MINOR_RELEASE' version.mk|cut -d'=' -f2|tr -d ' '`
VERSION3=`grep 'XMLRPC_POINT_RELEASE' version.mk|cut -d'=' -f2|tr -d ' '`
VERSION="$VERSION1.$VERSION2.$VERSION3"
echo "Version is: $VERSION"

sudo rm -rf xmlrpc-c-$VERSION 2>/dev/null
sudo rm /tmp/$NAME.tcz /tmp/$NAME.tcz.list /tmp/$NAME.tcz.md5.txt /tmp/$NAME.tcz.dep 2>/dev/null
sudo rm -rf /tmp/$NAME 2>/dev/null

echo "
Starting ./configure $CONFIGURE"
./configure $CONFIGURE
echo "Press ENTER to continue...
"
read
make -j3
echo "
Starting make install to: /tmp/$NAME"
sudo make DESTDIR=/tmp/$NAME install

cd /tmp/$NAME

sudo find . | xargs file | grep "executable" | grep ELF | grep "not stripped" | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
sudo find . | xargs file | grep "shared object" | grep ELF | grep "not stripped" | cut -f 1 -d : | xargs strip -g 2> /dev/null

cd /tmp/
sudo mv $NAME $NAME-dev
mkdir -p /tmp/$NAME/usr/local/lib
cd /tmp/$NAME-dev/usr/local/lib
sudo mv *.so* /tmp/$NAME/usr/local/lib/
sudo mv *.la* /tmp/$NAME/usr/local/lib/
sudo rm -rf /tmp/$NAME-dev/man

echo "Creating package..."
cd /tmp/
sudo mksquashfs $NAME $NAME.tcz
sudo md5sum $NAME.tcz > $NAME.tcz.md5.txt
cd $NAME
sudo find usr -not -type d > ../$NAME.tcz.list
cd /tmp/

SIZE="`du -k $NAME.tcz|cut -f1`k"
sudo echo "Title:          $NAME.tcz
Description:    XML-RPC library
Version:        $VERSION 
Author:         Sourceforge
Original-site:  http://xmlrpc-c.sourceforge.net/
Copying-policy: http://xmlrpc-c.svn.sourceforge.net/viewvc/xmlrpc-c/trunk/doc/COPYING
Size:           $SIZE
Extension_by:   andriscom
Comments:       A lightweight RPC library based on XML and HTTP.
                XML/RPC for C/C++ (Xmlrpc-c) is developed and distributed by a Sourceforge project.

                Built with CFLAGS: -march=i486 -mtune=i686 -Os -pipe
                Built with CXXFLAGS: -march=i486 -mtune=i686 -Os -pipe
                Built with LDFLAGS: -Wl,-O1
                Built with the following options:
                ./configure $CONFIGURE
Source:         $SOURCE
Change-log:     2010/09/28 First version (1.06.41 Super Stable)
                2010/10/16 Version: 1.16.31 - Added: CFLAGS, CXXFLAGS, LDFLAGS, dynamically linked curl
                2011/11/05 Version: 1.25.12 - Version update
Current:        $DATE Version: $VERSION - Version update, Added: xmlrpc-c-config script
" > $NAME.tcz.info

echo "Creating package..."
cd /tmp/
sudo mksquashfs $NAME-dev $NAME-dev.tcz
sudo md5sum $NAME-dev.tcz > $NAME-dev.tcz.md5.txt
cd $NAME-dev
sudo find usr -not -type d > ../$NAME-dev.tcz.list
cd /tmp/

SIZE="`du -k $NAME-dev.tcz|cut -f1`k"
sudo echo "Title:          $NAME-dev.tcz
Description:    XML-RPC library dev files
Version:        $VERSION 
Author:         Sourceforge
Original-site:  http://xmlrpc-c.sourceforge.net/
Copying-policy: http://xmlrpc-c.svn.sourceforge.net/viewvc/xmlrpc-c/trunk/doc/COPYING
Size:           $SIZE
Extension_by:   andriscom
Comments:       A lightweight RPC library based on XML and HTTP.
                XML/RPC for C/C++ (Xmlrpc-c) is developed and distributed by a Sourceforge project.

                Built with CFLAGS: -march=i486 -mtune=i686 -Os -pipe
                Built with CXXFLAGS: -march=i486 -mtune=i686 -Os -pipe
                Built with LDFLAGS: -Wl,-O1
                Built with the following options:
                ./configure $CONFIGURE
Source:         $SOURCE
Change-log:     2010/09/28 First version (1.06.41 Super Stable)
                2010/10/16 Version: 1.16.31 - Added: CFLAGS, CXXFLAGS, LDFLAGS, dynamically linked curl
                2011/11/05 Version: 1.25.12 - Version update
Current:        $DATE Version: $VERSION - Version update
" > $NAME-dev.tcz.info

sudo echo "$NAME.tcz
" > $NAME-dev.tcz.dep

cd /tmp/
mkdir packages 2>/dev/null
sudo rm packages/$NAME.tar.gz 2>/dev/null
sudo rm packages/$NAME-dev.tar.gz 2>/dev/null
tar zcf packages/$NAME.tar.gz $NAME.tcz* $NAME-dev.tcz* $SCRIPT_NAME
echo "
Run bcrypt on /tmp/packages/*.tar.gz... give password: tinycore"
echo "Run the extension_audit.sh and reboot a clean system to try the packages!"
echo "Send it to: tcesubmit@gmail.com"
